xref: /haiku/configure (revision 3facc270eae0beaa82bde86dbb4439ae30d24eba)
152a38012Sejakowatz#!/bin/sh
252a38012Sejakowatz#
3338b8dc3SIngo Weinhold# configure [ <options> ]
4614026d7Sshatty
5022fa244SIngo Weinhold# usage
6022fa244SIngo Weinhold#
7022fa244SIngo Weinhold# Prints usage.
8022fa244SIngo Weinhold#
9022fa244SIngo Weinholdusage()
10022fa244SIngo Weinhold{
11022fa244SIngo Weinhold	cat << EOF
12022fa244SIngo Weinhold
13022fa244SIngo WeinholdUsage: $0 <options>
14022fa244SIngo Weinholdoptions:
15825700d3SAugustin Cavalier  --help                      Prints out this help.
16825700d3SAugustin Cavalier  --update                    Re-runs last configure invocation [must be given
17825700d3SAugustin Cavalier                              as first option!]
18e173a1ecSIngo Weinhold  --bootstrap <haikuporter> <HaikuPorts cross repo> <HaikuPorts repo>
19e173a1ecSIngo Weinhold                              Prepare for a bootstrap build. No pre-built
20e173a1ecSIngo Weinhold                              packages will be used, instead they will be built
21e173a1ecSIngo Weinhold                              from the sources (in several phases).
22e173a1ecSIngo Weinhold                              <haikuporter> is the path to the haikuporter tool
23e173a1ecSIngo Weinhold                              suitable for the host platform.
24e173a1ecSIngo Weinhold                              <HaikuPorts cross repo> is the path to a checked
25e173a1ecSIngo Weinhold                              out HaikuPorts cross-compilation repository.
26e173a1ecSIngo Weinhold                              <HaikuPorts repo> is the path to a checked out
27e173a1ecSIngo Weinhold                              HaikuPorts repository.
28c0e8cc1aSIngo Weinhold  --build-cross-tools <arch> [ <build tools dir> ]
29338b8dc3SIngo Weinhold                              Assume cross compilation. <build tools dir>
30338b8dc3SIngo Weinhold                              defines the location of the build tools sources.
31338b8dc3SIngo Weinhold                              They will be compiled and placed in the output
32a5b60fa8SOliver Tappe                              directory under "cross-tools". The HAIKU_* tools
33a5b60fa8SOliver Tappe                              variables will be set accordingly.
3420ab75e6SIngo Weinhold                              <arch> specifies the target architecture, either
35fb4cc984SAugustin Cavalier                              "x86_gcc2", "x86", "x86_64", "ppc", "m68k", "arm", "arm64"
36c0e8cc1aSIngo Weinhold                              This option and --cross-tools-prefix can be
37c0e8cc1aSIngo Weinhold                              specified multiple times. The first cross tools
38c0e8cc1aSIngo Weinhold                              specify the primary tools, the subsequent ones the
39c0e8cc1aSIngo Weinhold                              secondary tools (for "hybrid" images).
40c0e8cc1aSIngo Weinhold                              For the first --build-cross-tools the
41c0e8cc1aSIngo Weinhold                              <build tools dir> argument must be specified and
42c0e8cc1aSIngo Weinhold                              for the subsequent ones it must be omitted.
43eccc7665SIngo Weinhold  --cross-tools-prefix <prefix>
44eccc7665SIngo Weinhold                              Assume cross compilation. <prefix> should be a
45eccc7665SIngo Weinhold                              path to the directory where the cross
46eccc7665SIngo Weinhold                              compilation tools are located, plus the platform
470da9c208SIngo Weinhold                              prefix, e.g. "/path/to/tools/i586-pc-haiku-".
48eccc7665SIngo Weinhold                              This overrides the HAIKU_* tool variables.
49a66c32ddSIngo Weinhold  --distro-compatibility <level>
50a66c32ddSIngo Weinhold                              The distribution's level of compatibility with
51a66c32ddSIngo Weinhold                              the official Haiku distribution. The generated
52a66c32ddSIngo Weinhold                              files will contain the respective trademarks
53a66c32ddSIngo Weinhold                              accordingly.
54a66c32ddSIngo Weinhold                              official -- the official Haiku distribution.
55a66c32ddSIngo Weinhold                              compatible -- a Haiku Compatible (tm) distro.
56a66c32ddSIngo Weinhold                              default -- any other distro (default value).
572ebcd86dSIngo Weinhold  --host-only                 Configure for building tools for the build host
582ebcd86dSIngo Weinhold                              only. Haiku cannot be built when configured like
592ebcd86dSIngo Weinhold                              this.
6076fa0be3SIngo Weinhold  --include-sources           Includes the source code of projects that require
6176fa0be3SIngo Weinhold                              either an offer of source code or a copy of the
6276fa0be3SIngo Weinhold                              patched sources. This is preferable when
6376fa0be3SIngo Weinhold                              distributing on physical mediums.
641974210fSFrançois Revol  --include-3rdparty          Include 3rdparty/ in the build system.
654880ae01SJessica Hamilton  -j<n>                       Only relevant for --build-cross-tools. Is passed
664880ae01SJessica Hamilton                              on to the make building the build tools.
67aa2e5ecaSOliver Tappe  --no-downloads              Do not download anything. Useful when trying to
68aa2e5ecaSOliver Tappe                              bootstrap and build Haiku from source only.
69483b28e4SIngo Weinhold  --target-arch <arch>        Haiku only: Specify the target architecture to
70483b28e4SIngo Weinhold                              build for. Must be one of the architectures of the
71483b28e4SIngo Weinhold                              host system. The installed build tools for that
72483b28e4SIngo Weinhold                              architecture will be used.
73483b28e4SIngo Weinhold                              This option can be specified multiple times. The
74483b28e4SIngo Weinhold                              first occurrence specifies the primary
75483b28e4SIngo Weinhold                              architecture of the Haiku to build, subsequent
76483b28e4SIngo Weinhold                              ones the secondary architectures.
77d73993ffSAugustin Cavalier  --use-clang <arch>          Build with host Clang instead of GCC cross
78d73993ffSAugustin Cavalier                              compiler, targeting <arch>
79eccc7665SIngo Weinhold  --use-gcc-pipe              Build with GCC option -pipe. Speeds up the build
805a34a443SFrançois Revol                              process, but uses more memory.
81ed38d2efSJerome Duval  --use-gcc-graphite          Build with GCC Graphite engine for loop
82a5c952dbSAugustin Cavalier                              optimizations. (Only for GCC 4+.)
830385b065SIngo Weinhold  --use-32bit                 Use -m32 flag on 64bit host gcc compiler.
84fc2c93fbSAugustin Cavalier  --no-full-xattr             Do not use Linux/*BSD/Darwin's native extended file
85fc2c93fbSAugustin Cavalier                              attributes as Haiku attributes. If they are still
86fc2c93fbSAugustin Cavalier                              available, they will be used to store hashes for
87fc2c93fbSAugustin Cavalier                              the attribute emulation layer.
88fc2c93fbSAugustin Cavalier  --no-xattr                  Do not use Linux/*BSD/Darwin's native extended file
89fc2c93fbSAugustin Cavalier                              attributes for Haiku extended attributes at all,
90fc2c93fbSAugustin Cavalier                              even if they are available.
914da6cf84SFrançois Revol  --with-gdb <gdb sources dir>
924da6cf84SFrançois Revol                              specify the path to a GDB source dir, to build
934da6cf84SFrançois Revol                              GDB for each arch we build the cross-tools for.
94338b8dc3SIngo Weinhold
95338b8dc3SIngo Weinholdenvironment variables:
9663701e7dSOliver Tappe  CC                          The host compiler. Defaults to "gcc".
9765706842SAugustin Cavalier  HAIKU_AR_<arch>             The static library archiver for <arch>.
98c0e8cc1aSIngo Weinhold                              Defaults to "ar".
9965706842SAugustin Cavalier  HAIKU_CC_<arch>             The compiler for <arch>. Defaults to "gcc".
10065706842SAugustin Cavalier  HAIKU_LD_<arch>             The <arch> linker. Defaults to "ld".
10165706842SAugustin Cavalier  HAIKU_OBJCOPY_<arch>        The <arch> objcopy to be used. Defaults to
102c0e8cc1aSIngo Weinhold                              "objcopy".
10365706842SAugustin Cavalier  HAIKU_RANLIB_<arch>         The static library indexer for <arch>. Defaults
104c0e8cc1aSIngo Weinhold                              to "ranlib".
10565706842SAugustin Cavalier  HAIKU_STRIP_<arch>          The <arch> strip command. Defaults to "strip".
106a04a520bSJonathan Schleifer  HAIKU_NASM                  The nasm assembler (x86 and x86_64 only).
107c0e8cc1aSIngo Weinhold  HAIKU_CPPFLAGS_<arch>       The preprocessor flags for target architecture
108c0e8cc1aSIngo Weinhold                              <arch>. Defaults to "".
109c0e8cc1aSIngo Weinhold  HAIKU_CCFLAGS_<arch>        The C flags for target architecture <arch>.
110c0e8cc1aSIngo Weinhold                              Defaults to "".
111c0e8cc1aSIngo Weinhold  HAIKU_CXXFLAGS_<arch>       The C++ flags for target architecture <arch>.
112c0e8cc1aSIngo Weinhold                              Defaults to "".
113252e4f62SAugustin Cavalier  HAIKU_LINKFLAGS_<arch>      The flags passed to the compiler when linking for
114252e4f62SAugustin Cavalier                              target architecture <arch>. Defaults to "".
115c0e8cc1aSIngo Weinhold  HAIKU_LDFLAGS_<arch>        The linker flags for target architecture <arch>.
116c0e8cc1aSIngo Weinhold                              Defaults to "".
117c0e8cc1aSIngo Weinhold  HAIKU_ARFLAGS_<arch>        The flags passed to HAIKU_AR for target
118c0e8cc1aSIngo Weinhold                              architecture <arch> for archiving. Defaults to
119c0e8cc1aSIngo Weinhold                              "cru".
120c0e8cc1aSIngo Weinhold  HAIKU_UNARFLAGS_<arch>      The flags passed to HAIKU_AR for target
121c0e8cc1aSIngo Weinhold                              architecture <arch> for unarchiving. Defaults to
122c0e8cc1aSIngo Weinhold                              "x".
12364f6da31SIngo Weinhold
124c0e8cc1aSIngo WeinholdNon-default output directories:
12564f6da31SIngo Weinhold  By default all objects, build configuration, and other related files are
12664f6da31SIngo Weinhold  stored in /path/to/haiku_source/generated.  To store objects in a non-default
12764f6da31SIngo Weinhold  location, run "../../relative/path/to/haiku_source/configure <options>" from
12864f6da31SIngo Weinhold  within your non-default location.  "jam [ options ] targets" can then be run
12964f6da31SIngo Weinhold  directly inside your non-default location.  Another option is to invoke "jam
13064f6da31SIngo Weinhold  [ options ] targets" from within haiku_source.  This can be accomplished by
13164f6da31SIngo Weinhold  either "export HAIKU_OUTPUT_DIR=your non-default location" before invoking
13264f6da31SIngo Weinhold  jam or by creating a symlink of haiku_source/generated pointing to your
13364f6da31SIngo Weinhold  non-default location and running jam.
13464f6da31SIngo Weinhold
13564f6da31SIngo Weinhold
136022fa244SIngo WeinholdEOF
137022fa244SIngo Weinhold}
138022fa244SIngo Weinhold
139022fa244SIngo Weinhold# assertparam
140022fa244SIngo Weinhold#
141022fa244SIngo Weinhold# Checks whether at least one parameter is left.
142022fa244SIngo Weinhold#
143022fa244SIngo Weinholdassertparam()
144022fa244SIngo Weinhold{
14520ab75e6SIngo Weinhold	if [ $2 -lt 2 ]; then
146022fa244SIngo Weinhold		echo $0: \`$1\': Parameter expected.
147022fa244SIngo Weinhold		exit 1
148022fa244SIngo Weinhold	fi
149022fa244SIngo Weinhold}
150022fa244SIngo Weinhold
15120ab75e6SIngo Weinhold# assertparams
15220ab75e6SIngo Weinhold#
15320ab75e6SIngo Weinhold# Checks whether at least a certain number of parameters is left.
15420ab75e6SIngo Weinhold#
15520ab75e6SIngo Weinholdassertparams()
15620ab75e6SIngo Weinhold{
15720ab75e6SIngo Weinhold	if [ $3 -le $2 ]; then
15820ab75e6SIngo Weinhold		echo $0: \`$1\': Not enough parameters.
15920ab75e6SIngo Weinhold		exit 1
16020ab75e6SIngo Weinhold	fi
16120ab75e6SIngo Weinhold}
16220ab75e6SIngo Weinhold
163e173a1ecSIngo Weinhold# absolute_path
164e173a1ecSIngo Weinhold#
165e173a1ecSIngo Weinhold# returns the absolute path of a given path.
166e173a1ecSIngo Weinhold#
167e173a1ecSIngo Weinholdabsolute_path()
168e173a1ecSIngo Weinhold{
1696a4f3954SFrançois Revol	if [ "x$1" != "x${1#/}" ]; then
170e173a1ecSIngo Weinhold		echo "$1"
171e173a1ecSIngo Weinhold	else
172e173a1ecSIngo Weinhold		echo "`pwd`/$1"
173e173a1ecSIngo Weinhold	fi
174e173a1ecSIngo Weinhold}
175e173a1ecSIngo Weinhold
17639d444a3SArvind S Raj# check_dir_exists
17739d444a3SArvind S Raj#
17839d444a3SArvind S Raj# check if a directory exists or not
17939d444a3SArvind S Raj#
18039d444a3SArvind S Rajcheck_dir_exists()
18139d444a3SArvind S Raj{
18239d444a3SArvind S Raj	if [ -d "$1" ]; then
18339d444a3SArvind S Raj		return 0
18439d444a3SArvind S Raj	else
18539d444a3SArvind S Raj		return 1
18639d444a3SArvind S Raj	fi
18739d444a3SArvind S Raj}
18839d444a3SArvind S Raj
189502882dbSJessica Hamilton# check_file_exists
190502882dbSJessica Hamilton#
191502882dbSJessica Hamilton# check if a file exists or not
192502882dbSJessica Hamilton#
193502882dbSJessica Hamiltoncheck_file_exists()
194502882dbSJessica Hamilton{
195502882dbSJessica Hamilton	if [ -f "$1" ]; then
196502882dbSJessica Hamilton		return 0
197502882dbSJessica Hamilton	else
198502882dbSJessica Hamilton		return 1
199502882dbSJessica Hamilton	fi
200502882dbSJessica Hamilton}
201502882dbSJessica Hamilton
2029a001156SOliver Tappe# real_path
2039a001156SOliver Tappe#
2049a001156SOliver Tappe# returns the realpath of a symbolic link.
2059a001156SOliver Tappe#
2069a001156SOliver Tappereal_path()
2079a001156SOliver Tappe{
2089a001156SOliver Tappe	perl -MCwd=realpath -e'print realpath($ARGV[0]), "\n"' "$1"
2099a001156SOliver Tappe}
2109a001156SOliver Tappe
211*3facc270SAugustin Cavalier# relative_to
212*3facc270SAugustin Cavalier#
213*3facc270SAugustin Cavalier# returns $1 relative to $2
214*3facc270SAugustin Cavalier#
215*3facc270SAugustin Cavalierrelative_to()
216*3facc270SAugustin Cavalier{
217*3facc270SAugustin Cavalier	perl -e 'use File::Spec; print File::Spec->abs2rel(@ARGV) . "\n"' \
218*3facc270SAugustin Cavalier		$1 $2
219*3facc270SAugustin Cavalier}
220*3facc270SAugustin Cavalier
221e5d446fcSAlexander von Gluck IV# valid_toolchain
222e5d446fcSAlexander von Gluck IV#
2231f839e89Swaddlesplash# check if a toolchain is valid
224e5d446fcSAlexander von Gluck IV#
225e5d446fcSAlexander von Gluck IVvalid_toolchain()
226e5d446fcSAlexander von Gluck IV{
227e5d446fcSAlexander von Gluck IV	TRIPLET="$1"
228e5d446fcSAlexander von Gluck IV	BASE="$2"
2291f839e89Swaddlesplash	SOURCE="$3"
230e5d446fcSAlexander von Gluck IV	if [ ! -d "$BASE" ]; then
2311f839e89Swaddlesplash		return 1
232e5d446fcSAlexander von Gluck IV	fi
233e5d446fcSAlexander von Gluck IV	if [ -f "$BASE/bin/$TRIPLET-gcc" ]; then
2341f839e89Swaddlesplash		[ "$BASE/bin/$TRIPLET-gcc" -nt "$SOURCE/legacy/gcc/configure" ] && \
2351f839e89Swaddlesplash			[ "$BASE/bin/$TRIPLET-gcc" -nt "$SOURCE/gcc/gcc/configure" ]
2361f839e89Swaddlesplash		return $?
237e5d446fcSAlexander von Gluck IV	fi
2381f839e89Swaddlesplash	return 1
239e5d446fcSAlexander von Gluck IV}
240e5d446fcSAlexander von Gluck IV
24109c5682dSIngo Weinhold# standard_gcc_settings
24209c5682dSIngo Weinhold#
24309c5682dSIngo Weinhold# Sets the variables for a GCC platform.
24409c5682dSIngo Weinhold#
24509c5682dSIngo Weinholdstandard_gcc_settings()
24609c5682dSIngo Weinhold{
24765706842SAugustin Cavalier	local gcc="$1"
248c0e8cc1aSIngo Weinhold
249138f5fb4SIngo Weinhold	if which greadlink > /dev/null 2>&1; then
250b29b48b1SMatt Madia		readlink="greadlink -e"
251138f5fb4SIngo Weinhold	elif which realpath > /dev/null 2>&1; then
252b29b48b1SMatt Madia		readlink=realpath
2539a001156SOliver Tappe	elif readlink -e / > /dev/null 2>&1; then
254b29b48b1SMatt Madia		readlink="readlink -e"
2559a001156SOliver Tappe	else
2569a001156SOliver Tappe		readlink=real_path
257b4b6d83cSMatt Madia	fi
258138f5fb4SIngo Weinhold
25909c5682dSIngo Weinhold	# PLATFORM_LINKLIBS
260c0e8cc1aSIngo Weinhold	local gcclib=`$gcc -print-libgcc-file-name`
261c0e8cc1aSIngo Weinhold	local gccdir=`dirname ${gcclib}`
2625b0f7b1bSOliver Tappe
263c0e8cc1aSIngo Weinhold	local gccRawVersion=`$gcc -dumpversion`
264c0e8cc1aSIngo Weinhold	local gccMachine=`$gcc -dumpmachine`
265338b8dc3SIngo Weinhold
266fc8967f1SIngo Weinhold	# determine architecture from machine triple
267c0e8cc1aSIngo Weinhold	case $gccMachine in
268c0e8cc1aSIngo Weinhold		arm-*)		targetCpu=arm;;
269fb4cc984SAugustin Cavalier		arm64-*)	targetCpu=arm64;;
270c0e8cc1aSIngo Weinhold		i?86-*)		targetCpu=x86;;
271c0e8cc1aSIngo Weinhold		m68k-*)		targetCpu=m68k;;
272c0e8cc1aSIngo Weinhold		powerpc-*)	targetCpu=ppc;;
273c0e8cc1aSIngo Weinhold		x86_64-*)	targetCpu=x86_64;;
274fc8967f1SIngo Weinhold		*)
275c0e8cc1aSIngo Weinhold			echo "Unsupported gcc target machine: $gccMachine" >&2
276fc8967f1SIngo Weinhold			exit 1
277fc8967f1SIngo Weinhold			;;
278fc8967f1SIngo Weinhold	esac
279fc8967f1SIngo Weinhold
280c0e8cc1aSIngo Weinhold	local targetArch=$targetCpu
281fc8967f1SIngo Weinhold
282c0e8cc1aSIngo Weinhold	case $gccRawVersion in
2836cc8eecfSOliver Tappe		2.9*)
2845b0f7b1bSOliver Tappe			# check for correct (most up-to-date) legacy compiler and complain
2855b0f7b1bSOliver Tappe			# if an older one is installed
286c0e8cc1aSIngo Weinhold			if [ $gccRawVersion != $haikuRequiredLegacyGCCVersion ]; then
2875b0f7b1bSOliver Tappe				echo "GCC version $haikuRequiredLegacyGCCVersion is required!";
2885b0f7b1bSOliver Tappe				echo "Please download it from www.haiku-os.org...";
2895b0f7b1bSOliver Tappe				exit 1;
2905b0f7b1bSOliver Tappe			fi
291aaeadfcbSAlex Smith
292c0e8cc1aSIngo Weinhold			targetArch=x86_gcc2
2935b0f7b1bSOliver Tappe			;;
2948b5934c9SIngo Weinhold	esac
29565ad1ba3SAlex Smith
296c0e8cc1aSIngo Weinhold	local bootLibgcc
297c0e8cc1aSIngo Weinhold	local bootLibSupCxx
29866a7f29fSJérôme Duval	local bootCxxHeaders
299c0e8cc1aSIngo Weinhold	case $gccMachine in
3004591ebc9SAlex Smith		x86_64-*)
30166a7f29fSJérôme Duval			# Boot loader is 32-bit, need the 32-bit libs and c++ config
30211ae3c5fSOliver Tappe			bootLibgcc=`$gcc -m32 -print-file-name=libgcc.a`
303c0e8cc1aSIngo Weinhold			bootLibSupCxx=`$gcc -m32 -print-file-name=libsupc++.a`
30466a7f29fSJérôme Duval
30566a7f29fSJérôme Duval			local headersBase=$gccdir/../../../..
30666a7f29fSJérôme Duval			local headers=$headersBase/$gccMachine/include/c++/$gccRawVersion
30766a7f29fSJérôme Duval			if [ ! -d $headers ]; then
30866a7f29fSJérôme Duval				headers=$headersBase/include/c++/$gccRawVersion
30966a7f29fSJérôme Duval			fi
31066a7f29fSJérôme Duval			bootCxxHeaders="$headers/$gccMachine/32"
3114591ebc9SAlex Smith			;;
312338b8dc3SIngo Weinhold	esac
313c0e8cc1aSIngo Weinhold
314c0e8cc1aSIngo Weinhold	# determine whether graphite loop optimization should/can be used
315c0e8cc1aSIngo Weinhold	local useGraphite=`get_variable HAIKU_USE_GCC_GRAPHITE_$targetCpu`
316c0e8cc1aSIngo Weinhold	if [ -z "$useGraphite" ]; then
317c0e8cc1aSIngo Weinhold		useGraphite=$useGccGraphiteDefault
318c0e8cc1aSIngo Weinhold	fi
319c0e8cc1aSIngo Weinhold
320c0e8cc1aSIngo Weinhold	if [ "$useGraphite" != 0 ]; then
321c0e8cc1aSIngo Weinhold		UNUSED=`echo "int main() {}" | $gcc -xc -c -floop-block - 2>&1`
322c0e8cc1aSIngo Weinhold		if [ $? != 0 ]; then
323c0e8cc1aSIngo Weinhold			echo "GCC Graphite loop optimizations cannot be used on $targetArch"
324c0e8cc1aSIngo Weinhold			useGraphite=0
325c0e8cc1aSIngo Weinhold		fi
326c0e8cc1aSIngo Weinhold	fi
327c0e8cc1aSIngo Weinhold
328c0e8cc1aSIngo Weinhold	set_variable HAIKU_CPU_$targetArch $targetCpu
329c0e8cc1aSIngo Weinhold
330c0e8cc1aSIngo Weinhold	get_build_tool_path CC_$targetArch "$gcc"
331a7bddff1SJonathan Schleifer	set_variable HAIKU_CC_IS_CLANG_$targetArch $useClang
332c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_RAW_VERSION_$targetArch $gccRawVersion
333c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_MACHINE_$targetArch $gccMachine
334c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_LIB_DIR_$targetArch $gccdir
33566a7f29fSJérôme Duval	set_variable HAIKU_BOOT_CXX_HEADERS_DIR_$targetArch "$bootCxxHeaders"
33611ae3c5fSOliver Tappe	set_variable HAIKU_BOOT_LIBSUPCXX_$targetArch "$bootLibSupCxx"
33711ae3c5fSOliver Tappe	set_variable HAIKU_BOOT_LIBGCC_$targetArch $bootLibgcc
338c0e8cc1aSIngo Weinhold	set_variable HAIKU_USE_GCC_GRAPHITE_$targetArch $useGraphite
339c0e8cc1aSIngo Weinhold
340c0e8cc1aSIngo Weinhold	standard_gcc_settings_targetArch=$targetArch
341c0e8cc1aSIngo Weinhold}
342c0e8cc1aSIngo Weinhold
343c0e8cc1aSIngo Weinhold# set_variable
344c0e8cc1aSIngo Weinhold#
345c0e8cc1aSIngo Weinhold# Set the value of a variable.
346c0e8cc1aSIngo Weinhold#
347c0e8cc1aSIngo Weinholdset_variable()
348c0e8cc1aSIngo Weinhold{
349c0e8cc1aSIngo Weinhold	eval "$1=\"$2\""
350c0e8cc1aSIngo Weinhold}
351c0e8cc1aSIngo Weinhold
352c0e8cc1aSIngo Weinhold# get_variable
353c0e8cc1aSIngo Weinhold#
354c0e8cc1aSIngo Weinhold# Echo the value of a variable.
355c0e8cc1aSIngo Weinhold#
356c0e8cc1aSIngo Weinholdget_variable()
357c0e8cc1aSIngo Weinhold{
358c0e8cc1aSIngo Weinhold	eval "echo \${$1}"
35909c5682dSIngo Weinhold}
36009c5682dSIngo Weinhold
361338b8dc3SIngo Weinhold# set_default_value
362338b8dc3SIngo Weinhold#
363338b8dc3SIngo Weinhold# Set the value for a variable, if no value is set yet.
364338b8dc3SIngo Weinhold#
365338b8dc3SIngo Weinholdset_default_value()
366338b8dc3SIngo Weinhold{
3670838a930SJérôme Duval	eval "$1=\${$1-$2}"
368338b8dc3SIngo Weinhold}
369338b8dc3SIngo Weinhold
370338b8dc3SIngo Weinhold# get_build_tool_path
371338b8dc3SIngo Weinhold#
372338b8dc3SIngo Weinhold# Gets a usable absolute path of a build tool.
373338b8dc3SIngo Weinhold#
374338b8dc3SIngo Weinholdget_build_tool_path()
375338b8dc3SIngo Weinhold{
376338b8dc3SIngo Weinhold	local var="HAIKU_$1"
37765706842SAugustin Cavalier	local varval="`get_variable $var`"
37865706842SAugustin Cavalier	local cmd="$2"
379d73993ffSAugustin Cavalier
380e042a53bSAugustin Cavalier	if [ ! -z "$varval" ]; then
381d73993ffSAugustin Cavalier		# this variable is already set (probably by user) so grab its contents
382e042a53bSAugustin Cavalier		cmd=$varval
383d73993ffSAugustin Cavalier	fi
384d73993ffSAugustin Cavalier
385d73993ffSAugustin Cavalier	local path=${cmd%% *}
386338b8dc3SIngo Weinhold
387338b8dc3SIngo Weinhold	if [ -f "$path" ]; then
38865706842SAugustin Cavalier		# get absolute path from relative path
389a559f87aSFrançois Revol		local oldPwd="`pwd`"
390a559f87aSFrançois Revol		cd "`dirname "$path"`"
391a559f87aSFrançois Revol		path="`pwd`/`basename "$path"`"
392338b8dc3SIngo Weinhold		cd $oldPwd
393338b8dc3SIngo Weinhold	else
3947fe2e06cSMatt Madia		which "$path" > /dev/null 2>&1 || {
395d73993ffSAugustin Cavalier			echo "Build tool \"$path\" not found (maybe specify it in $var?)" >&2
396338b8dc3SIngo Weinhold			exit 1
397338b8dc3SIngo Weinhold		}
398338b8dc3SIngo Weinhold	fi
399338b8dc3SIngo Weinhold
40065706842SAugustin Cavalier	if test "${cmd#* }" != "$cmd"; then
40165706842SAugustin Cavalier		# $cmd contains arguments, so preserve them (and only them)
40265706842SAugustin Cavalier		cmd=${cmd#* }
40365706842SAugustin Cavalier	else
40465706842SAugustin Cavalier		# $cmd does not contain arguments, so unset it
40565706842SAugustin Cavalier		cmd=
40665706842SAugustin Cavalier	fi
40765706842SAugustin Cavalier	eval "$var=\"$path $cmd\""
408338b8dc3SIngo Weinhold}
409338b8dc3SIngo Weinhold
410a5c952dbSAugustin Cavalier# check_native_xattrs
411a5c952dbSAugustin Cavalier#
412a5c952dbSAugustin Cavalier# Checks the host platform's support for extended attributes.
413a5c952dbSAugustin Cavalier# 0: no support, 1: only enough for xattr-ref, 2: full support
414a5c952dbSAugustin Cavalier#
415a5c952dbSAugustin Cavaliercheck_native_xattrs()
416a5c952dbSAugustin Cavalier{
417a5c952dbSAugustin Cavalier	local xattr_set=
418a5c952dbSAugustin Cavalier	local xattr_set_args=
419a5c952dbSAugustin Cavalier	local xattr_get=
420a5c952dbSAugustin Cavalier	local xattr_get_args=
421a5c952dbSAugustin Cavalier	case $HOST_PLATFORM in
422503ef6d4SAugustin Cavalier		haiku_host)
423503ef6d4SAugustin Cavalier			xattr_set="addattr"; xattr_set_args="\$NAME \"\$VALUE\""
424503ef6d4SAugustin Cavalier			xattr_get="catattr"; xattr_get_args="\$NAME"
425503ef6d4SAugustin Cavalier			;;
426a5c952dbSAugustin Cavalier		darwin)
427a5c952dbSAugustin Cavalier			xattr_set="xattr"; xattr_set_args="-w \$NAME \"\$VALUE\""
428a5c952dbSAugustin Cavalier			xattr_get="xattr"; xattr_get_args="-p \$NAME"
429a5c952dbSAugustin Cavalier			;;
430a5c952dbSAugustin Cavalier		freebsd)
431a5c952dbSAugustin Cavalier			xattr_set="setextattr"; xattr_set_args="user \$NAME \"\$VALUE\""
432a5c952dbSAugustin Cavalier			xattr_get="getextattr"; xattr_get_args="user \$NAME"
433a5c952dbSAugustin Cavalier			;;
434a5c952dbSAugustin Cavalier		linux)
435a5c952dbSAugustin Cavalier			xattr_set="setfattr"; xattr_set_args="-n user.\$NAME -v \"\$VALUE\""
436a5c952dbSAugustin Cavalier			xattr_get="getfattr"; xattr_get_args="-n user.\$NAME"
437a5c952dbSAugustin Cavalier			;;
438a5c952dbSAugustin Cavalier		*)
439a5c952dbSAugustin Cavalier			return 0
440a5c952dbSAugustin Cavalier			;;
441a5c952dbSAugustin Cavalier	esac
442a5c952dbSAugustin Cavalier	if ! type $xattr_set >/dev/null 2>&1; then
443a5c952dbSAugustin Cavalier		echo "$0: could not find $xattr_set, assuming host has no extended attributes"
444a5c952dbSAugustin Cavalier		return 0
445a5c952dbSAugustin Cavalier	elif ! type $xattr_get >/dev/null 2>&1; then
446a5c952dbSAugustin Cavalier		echo "$0: could not find $xattr_get, assuming host has no extended attributes"
447a5c952dbSAugustin Cavalier		return 0
448a5c952dbSAugustin Cavalier	fi
449a5c952dbSAugustin Cavalier
45043f5f35aSAugustin Cavalier	mkdir -p "$outputDir"
451a5c952dbSAugustin Cavalier	echo "xattr test file" >"$outputDir/xattrtest"
452a5c952dbSAugustin Cavalier	local i=0
453a5c952dbSAugustin Cavalier	# on round 0, we test if we can set 3 attrs of 1K each (enough for xattr-ref)
454a5c952dbSAugustin Cavalier	# on round 1, we test if we can set 3 attrs of 45K each (enough for full xattr)
455a5c952dbSAugustin Cavalier	while [ $i -lt 2 ]; do
456a5c952dbSAugustin Cavalier		local j=0
457a5c952dbSAugustin Cavalier		while [ $j -lt 3 ]; do
458a5c952dbSAugustin Cavalier			NAME=attr$j
459a5c952dbSAugustin Cavalier			VALUE=`printf '%*s' $((1024 + $i * 45056)) "" | tr ' ' x`
460a5c952dbSAugustin Cavalier			if [ `echo -n $VALUE | wc -c` -lt $((1024 + $i * 45056)) ]; then
461a5c952dbSAugustin Cavalier				echo "$0: warning: could not generate test data for extended attributes"
462a5c952dbSAugustin Cavalier				rm "$outputDir/xattrtest"
463a5c952dbSAugustin Cavalier				return $i
464a5c952dbSAugustin Cavalier			elif ! $xattr_set `eval echo \"$xattr_set_args\"` \
465a5c952dbSAugustin Cavalier					"$outputDir/xattrtest" >/dev/null 2>&1 ; then
466a5c952dbSAugustin Cavalier				rm "$outputDir/xattrtest"
467a5c952dbSAugustin Cavalier				return $i
468a5c952dbSAugustin Cavalier			fi
469a5c952dbSAugustin Cavalier			j=$((j+1))
470a5c952dbSAugustin Cavalier		done
471a5c952dbSAugustin Cavalier		i=$((i+1))
472a5c952dbSAugustin Cavalier	done
473a5c952dbSAugustin Cavalier	rm "$outputDir/xattrtest"
474a5c952dbSAugustin Cavalier	return 2
475a5c952dbSAugustin Cavalier}
476a5c952dbSAugustin Cavalier
477483b28e4SIngo Weinholdis_in_list()
478483b28e4SIngo Weinhold{
479483b28e4SIngo Weinhold	local element
480483b28e4SIngo Weinhold	for element in $2; do
481483b28e4SIngo Weinhold		if [ "$1" = "$element" ]; then
482483b28e4SIngo Weinhold			return 0
483483b28e4SIngo Weinhold		fi
484483b28e4SIngo Weinhold	done
485483b28e4SIngo Weinhold	return 1
486483b28e4SIngo Weinhold}
487483b28e4SIngo Weinhold
4887f9beaf1SOliver Tappe# check for --help or -h and show usage immediately
4897f9beaf1SOliver Tappeif [ "$1" = "--help" ] || [ "$1" = "-h" ]; then
4908b420c2fSOliver Tappe	usage; exit 0;
4918b420c2fSOliver Tappefi
4928b420c2fSOliver Tappe
493338b8dc3SIngo Weinhold# get cwd and the source directory
494338b8dc3SIngo WeinholdcurrentDir=`pwd`
4956e7c6fe5SIngo Weinholdcd `dirname "$0"`
496338b8dc3SIngo WeinholdsourceDir=`pwd`
4976e7c6fe5SIngo Weinholdcd "$currentDir"
498338b8dc3SIngo Weinhold
499a107d3b4SAugustin Cavalier# determine output directory
500a107d3b4SAugustin Cavalierif [ "$currentDir" = "$sourceDir" ]; then
501a107d3b4SAugustin Cavalier	outputDir=$currentDir/generated
502a107d3b4SAugustin Cavalierelse
503a107d3b4SAugustin Cavalier	outputDir=$currentDir
504a107d3b4SAugustin Cavalierfi
505a107d3b4SAugustin CavalierbuildOutputDir="$outputDir/build"
506a107d3b4SAugustin CavalierHAIKU_BUILD_ATTRIBUTES_DIR="$outputDir/attributes"
507a107d3b4SAugustin CavalierbuildConfigFile="$buildOutputDir/BuildConfig"
508a107d3b4SAugustin Cavalier
509a107d3b4SAugustin Cavalier# check for update request
510a107d3b4SAugustin Cavalierif [ "$1" = "--update" ]; then
511a107d3b4SAugustin Cavalier	if ! [ -e "$buildConfigFile" ]; then
512a107d3b4SAugustin Cavalier		echo $0 --update: \'$buildConfigFile\' not found - updating not possible.
513a107d3b4SAugustin Cavalier		exit 1
514a107d3b4SAugustin Cavalier	fi
515a107d3b4SAugustin Cavalier	# get last configure invocation and flags from BuildConfig and call ourselves with it
516a107d3b4SAugustin Cavalier	lastPwd=`grep "#d " "$buildConfigFile" | cut -c 4-`
517a107d3b4SAugustin Cavalier	lastConfig=`grep "#c " "$buildConfigFile" | cut -c 4-`
518a107d3b4SAugustin Cavalier	lastEnv=`grep "#e " "$buildConfigFile" | cut -c 4-`
519a107d3b4SAugustin Cavalier	lastArgs=`grep "#a " "$buildConfigFile" | cut -c 4-`
520a107d3b4SAugustin Cavalier	if [ -z "$lastConfig" ]; then
521a107d3b4SAugustin Cavalier		echo "$0 --update: The previous configure invocation was not properly" \
522a107d3b4SAugustin Cavalier			"encoded into '$buildConfigFile' - updating not possible."
523a107d3b4SAugustin Cavalier		exit 1
524a107d3b4SAugustin Cavalier	fi
525a107d3b4SAugustin Cavalier	cd $lastPwd
526a107d3b4SAugustin Cavalier	if [ -n "$lastEnv" ]; then
527a107d3b4SAugustin Cavalier		export $lastEnv
528a107d3b4SAugustin Cavalier	fi
529a107d3b4SAugustin Cavalier	$lastConfig $lastArgs
530a107d3b4SAugustin Cavalier	exit $?
531a107d3b4SAugustin Cavalierfi
532a107d3b4SAugustin Cavalier
53355d267a4SFrançois Revol# backup the passed arguments
53455d267a4SFrançois RevolconfigureArgs="$@"
535825700d3SAugustin CavalierconfigurePath=$0
536825700d3SAugustin Cavalier
537825700d3SAugustin Cavalier# backup relevant environs
538825700d3SAugustin CavalierconfigureEnvirons=
539825700d3SAugustin Cavalierfor var in `env`; do
540825700d3SAugustin Cavalier	case "$var" in
541825700d3SAugustin Cavalier		CC\=*|HAIKU*\=*)
542825700d3SAugustin Cavalier			configureEnvirons="$configureEnvirons $var"
543825700d3SAugustin Cavalier			;;
544825700d3SAugustin Cavalier	esac
545825700d3SAugustin Cavalierdone
54655d267a4SFrançois Revol
547a107d3b4SAugustin Cavalier# ensure umask is not too restrictive
54802f3646aSAugustin Cavalierif [ `umask` -gt 22 ]; then
54902f3646aSAugustin Cavalier	echo Your umask is too restrictive "(should be <= 0022;" is actually `umask`")"
55002f3646aSAugustin Cavalier	echo
55102f3646aSAugustin Cavalier	echo Additionally, if the source tree was cloned with a too-restrictive umask,
55202f3646aSAugustin Cavalier	echo you will need to run \"git checkout\" again to fix this.
553a107d3b4SAugustin Cavalier	exit 1
554a107d3b4SAugustin Cavalierfi
55502f3646aSAugustin Cavalier# ensure git checkout was not done with a restrictive umask
556ca20bd2eSAugustin Cavalierif [ `stat -c '%a' $sourceDir/data/system/boot/SetupEnvironment` -lt 644 ]; then
55702f3646aSAugustin Cavalier	echo "The source tree was cloned with a umask > 0022. It seems you"
55802f3646aSAugustin Cavalier	echo have already corrected your umask, but not re-checked-out the
55902f3646aSAugustin Cavalier	echo source tree. Try running:
56002f3646aSAugustin Cavalier	echo "	git checkout --force"
56102f3646aSAugustin Cavalier	echo to fix this problem.
56202f3646aSAugustin Cavalier	exit 1
56302f3646aSAugustin Cavalierfi
56402f3646aSAugustin Cavalier
565a107d3b4SAugustin Cavalier
5667c4641d0SOliver Tappe# internal default parameter values
567022fa244SIngo Weinhold#
56852a38012Sejakowatzplatform=`uname`
5695abd9a46SIngo WeinholdplatformMachine=`uname  -m`
570c0e8cc1aSIngo WeinholdtargetArchs=
571338b8dc3SIngo WeinholdbuildCrossTools=
57229ef597dSIngo WeinholdbuildCrossToolsScript="$sourceDir/build/scripts/build_cross_tools"
57360d8d8fcSIngo WeinholdbuildCrossToolsJobs=
574c2b76f7fSJonathan SchleiferuseClang=0
575c0e8cc1aSIngo WeinholduseGccGraphiteDefault=0
576c0e8cc1aSIngo WeinholdunknownArchIndex=1
577483b28e4SIngo WeinholdhaikuTargetArchs=
5784da6cf84SFrançois RevolgdbSources=
5797c4641d0SOliver Tappe
58063701e7dSOliver Tappeif [ -z "$CC" ]; then
58163701e7dSOliver Tappe	CC=gcc
58263701e7dSOliver Tappefi
58363701e7dSOliver Tappe
5847c4641d0SOliver Tappe# exported (BuildSetup) default parameter values
5857c4641d0SOliver Tappe#
58663701e7dSOliver TappeHOST_GCC_RAW_VERSION=`$CC -dumpversion`
58763701e7dSOliver TappeHOST_GCC_MACHINE=`$CC -dumpmachine`
58876fa0be3SIngo WeinholdHAIKU_INCLUDE_SOURCES=0
5897c4641d0SOliver TappeHAIKU_INCLUDE_3RDPARTY=0
5907c4641d0SOliver TappeHAIKU_DISTRO_COMPATIBILITY=default
5917c4641d0SOliver TappeTARGET_PLATFORM=haiku
5927c4641d0SOliver TappeHAIKU_USE_GCC_PIPE=0
5937986925fSIngo WeinholdHAIKU_HOST_USE_32BIT=0
594fc2c93fbSAugustin CavalierHAIKU_HOST_USE_XATTR=
595fc2c93fbSAugustin CavalierHAIKU_HOST_USE_XATTR_REF=
5962ebcd86dSIngo WeinholdHAIKU_HOST_BUILD_ONLY=0
597f04f7042SNiels Sascha ReedijkHOST_EXTENDED_REGEX_SED="sed -r"
59863701e7dSOliver TappeHOST_GCC_LD=`$CC -print-prog-name=ld`
59963701e7dSOliver TappeHOST_GCC_OBJCOPY=`$CC -print-prog-name=objcopy`
6002a5d0aafSIngo WeinholdHOST_SHA256=
601e173a1ecSIngo WeinholdHOST_HAIKU_PORTER=
602e173a1ecSIngo WeinholdHAIKU_PORTS=
603e173a1ecSIngo WeinholdHAIKU_PORTS_CROSS=
604c9dd05ffSJonathan SchleiferHAIKU_IS_BOOTSTRAP=0
605aa2e5ecaSOliver TappeHAIKU_NO_DOWNLOADS=0
6062a5d0aafSIngo Weinhold
607c0e8cc1aSIngo WeinholdHAIKU_PACKAGING_ARCHS=
608c0e8cc1aSIngo Weinhold
609a04a520bSJonathan Schleiferset_default_value HAIKU_NASM		nasm
610c0e8cc1aSIngo Weinhold
6113942ca0dSIngo Weinholdif sha256sum < /dev/null > /dev/null 2>&1; then
6122a5d0aafSIngo Weinhold	HOST_SHA256=sha256sum
6133942ca0dSIngo Weinholdelif sha256 < /dev/null > /dev/null 2>&1; then
6142a5d0aafSIngo Weinhold	HOST_SHA256="sha256 -q"
615b5a871b1SNiels Sascha Reedijkelif shasum < /dev/null > /dev/null 2>&1; then
616b5a871b1SNiels Sascha Reedijk	HOST_SHA256="shasum -a 256"
6172a5d0aafSIngo Weinholdelse
6182a5d0aafSIngo Weinhold	echo "Error: Neither sha256sum nor sha256 seem to be available!" >&2
6192a5d0aafSIngo Weinhold	exit 1
6202a5d0aafSIngo Weinholdfi
621338b8dc3SIngo Weinhold
62284edb1a1SAxel DörflerhaikuRequiredLegacyGCCVersion="2.95.3-haiku-2017_07_20"
623a559f87aSFrançois Revolexport haikuRequiredLegacyGCCVersion
624af4bf973SOliver Tappe	# version of legacy gcc required to build haiku
625483b28e4SIngo WeinholdsupportedTargetArchs="
626483b28e4SIngo Weinhold	arm
627fb4cc984SAugustin Cavalier	arm64
628483b28e4SIngo Weinhold	m68k
629483b28e4SIngo Weinhold	ppc
630483b28e4SIngo Weinhold	x86
631483b28e4SIngo Weinhold	x86_64
632483b28e4SIngo Weinhold	x86_gcc2
633483b28e4SIngo Weinhold	"
634af4bf973SOliver Tappe
635022fa244SIngo Weinhold# parse parameters
636022fa244SIngo Weinhold#
63720ab75e6SIngo Weinholdwhile [ $# -gt 0 ] ; do
638022fa244SIngo Weinhold	case "$1" in
639e173a1ecSIngo Weinhold		--bootstrap)
640e173a1ecSIngo Weinhold			assertparams "$1" 3 $#
641e173a1ecSIngo Weinhold			HOST_HAIKU_PORTER="`absolute_path $2`"
642e173a1ecSIngo Weinhold			HAIKU_PORTS_CROSS="`absolute_path $3`"
643e173a1ecSIngo Weinhold			HAIKU_PORTS="`absolute_path $4`"
644c9dd05ffSJonathan Schleifer			HAIKU_IS_BOOTSTRAP=1
645c9dd05ffSJonathan Schleifer			HAIKU_NO_DOWNLOADS=1
646502882dbSJessica Hamilton			check_file_exists "$HOST_HAIKU_PORTER" || (
647502882dbSJessica Hamilton				echo "Invalid path to haikuporter: $HOST_HAIKU_PORTER" >&2
64839d444a3SArvind S Raj				exit 1
64939d444a3SArvind S Raj			)
65039d444a3SArvind S Raj			check_dir_exists "$HAIKU_PORTS" || (
65139d444a3SArvind S Raj				echo "Non-existent directory $HAIKU_PORTS" >&2
65239d444a3SArvind S Raj				exit 1
65339d444a3SArvind S Raj			)
65439d444a3SArvind S Raj			check_dir_exists "$HAIKU_PORTS_CROSS" || (
65539d444a3SArvind S Raj				echo "Non-existent directory $HAIKU_PORTS_CROSS" >&2
65639d444a3SArvind S Raj				exit 1
65739d444a3SArvind S Raj			)
658e173a1ecSIngo Weinhold			shift 4
659e173a1ecSIngo Weinhold			;;
660c0e8cc1aSIngo Weinhold		--build-cross-tools)
661c0e8cc1aSIngo Weinhold			if [ -z "$buildCrossTools" ]; then
6629b0dd528SIngo Weinhold				assertparams "$1" 2 $#
663c0e8cc1aSIngo Weinhold				targetArch=$2
6649b0dd528SIngo Weinhold				buildCrossTools=$3
6659b0dd528SIngo Weinhold				shift 3
666c0e8cc1aSIngo Weinhold			else
667c0e8cc1aSIngo Weinhold				assertparam "$1" $#
668c0e8cc1aSIngo Weinhold				targetArch=$2
669c0e8cc1aSIngo Weinhold				shift 2
670c0e8cc1aSIngo Weinhold			fi
671c0e8cc1aSIngo Weinhold			case "$targetArch" in
672c0e8cc1aSIngo Weinhold				x86_gcc2)	targetMachine=i586-pc-haiku;;
673c0e8cc1aSIngo Weinhold				x86)		targetMachine=i586-pc-haiku;;
674c0e8cc1aSIngo Weinhold				x86_64)		targetMachine=x86_64-unknown-haiku;;
675c0e8cc1aSIngo Weinhold				ppc)		targetMachine=powerpc-apple-haiku;;
676c0e8cc1aSIngo Weinhold				m68k)		targetMachine=m68k-unknown-haiku;;
677c0e8cc1aSIngo Weinhold				arm)		targetMachine=arm-unknown-haiku;;
678c0e8cc1aSIngo Weinhold				*)
679101564e4SAugustin Cavalier					echo "Unsupported target architecture: $targetArch" >&2
680c0e8cc1aSIngo Weinhold					exit 1
681c0e8cc1aSIngo Weinhold					;;
682c0e8cc1aSIngo Weinhold			esac
683c0e8cc1aSIngo Weinhold			set_variable buildCrossToolsMachine_$targetArch $targetMachine
684c0e8cc1aSIngo Weinhold			targetArchs="$targetArchs $targetArch"
6859b0dd528SIngo Weinhold			;;
6869b0dd528SIngo Weinhold		--cross-tools-prefix)
6879b0dd528SIngo Weinhold			assertparam "$1" $#
688c0e8cc1aSIngo Weinhold			targetArch=unknown${unknownArchIndex}
689c0e8cc1aSIngo Weinhold			set_variable crossToolsPrefix_$targetArch "$2"
690c0e8cc1aSIngo Weinhold			targetArchs="$targetArchs $targetArch"
691d68208faSMatt Madia			unknownArchIndex=$(($unknownArchIndex + 1))
6929b0dd528SIngo Weinhold			shift 2
6939b0dd528SIngo Weinhold			;;
694a66c32ddSIngo Weinhold		--distro-compatibility)
6959b0dd528SIngo Weinhold			assertparam "$1" $#
6967c4641d0SOliver Tappe			HAIKU_DISTRO_COMPATIBILITY=$2
6977c4641d0SOliver Tappe			case "$HAIKU_DISTRO_COMPATIBILITY" in
698a66c32ddSIngo Weinhold				official)	;;
699a66c32ddSIngo Weinhold				compatible)	;;
700a66c32ddSIngo Weinhold				default)	;;
701a66c32ddSIngo Weinhold				*)			echo "Invalid distro compatibility" \
7027c4641d0SOliver Tappe								"level: $HAIKU_DISTRO_COMPATIBILITY"
703a66c32ddSIngo Weinhold							exit 1;;
704a66c32ddSIngo Weinhold			esac
7059b0dd528SIngo Weinhold			shift 2
7069b0dd528SIngo Weinhold			;;
7072ebcd86dSIngo Weinhold		--host-only)	HAIKU_HOST_BUILD_ONLY=1; shift 1;;
70876fa0be3SIngo Weinhold		--include-sources)	HAIKU_INCLUDE_SOURCES=1; shift 1;;
7097c4641d0SOliver Tappe		--include-3rdparty)	HAIKU_INCLUDE_3RDPARTY=1; shift 1;;
71060d8d8fcSIngo Weinhold        -j*)				buildCrossToolsJobs="$1"; shift 1;;
711aa2e5ecaSOliver Tappe		--no-downloads)	HAIKU_NO_DOWNLOADS=1; shift 1;;
712483b28e4SIngo Weinhold		--target-arch)
713483b28e4SIngo Weinhold			assertparam "$1" $#
714483b28e4SIngo Weinhold			targetArch=$2
715483b28e4SIngo Weinhold			shift 2
716483b28e4SIngo Weinhold			if [ ! "$platform" = Haiku ]; then
717483b28e4SIngo Weinhold				echo "--target-arch can only be specified on Haiku." >&2
718483b28e4SIngo Weinhold				exit 1
719483b28e4SIngo Weinhold			fi
720483b28e4SIngo Weinhold			is_in_list "$targetArch" "$supportedTargetArchs" || (
721483b28e4SIngo Weinhold				echo "Unsupported target architecture: \"$targetArch\"" >&2
722483b28e4SIngo Weinhold				exit 1
723483b28e4SIngo Weinhold			)
724483b28e4SIngo Weinhold			haikuTargetArchs="$haikuTargetArchs $targetArch"
725483b28e4SIngo Weinhold			;;
726d73993ffSAugustin Cavalier		--use-clang)
727d73993ffSAugustin Cavalier			assertparam "$1" $#
728d73993ffSAugustin Cavalier			targetArch=$2
729d73993ffSAugustin Cavalier			useClang=1
730d73993ffSAugustin Cavalier			case "$targetArch" in
731d73993ffSAugustin Cavalier				x86)		targetMachine=i586-pc-haiku;;
732d73993ffSAugustin Cavalier				x86_64)		targetMachine=x86_64-unknown-haiku;;
733d9f698eaSAugustin Cavalier				ppc)		targetMachine=powerpc-apple-haiku;;
73420dbf032SAlexander von Gluck IV				arm)		targetMachine=arm-unknown-haiku;;
735fb4cc984SAugustin Cavalier				arm64)		targetMachine=arm64-unknown-haiku;;
736d73993ffSAugustin Cavalier				*)
737d73993ffSAugustin Cavalier					echo "Unsupported target architecture: $2" >&2
738d73993ffSAugustin Cavalier					exit 1
739d73993ffSAugustin Cavalier					;;
740d73993ffSAugustin Cavalier			esac
74165706842SAugustin Cavalier			get_build_tool_path clang clang
74236f28382SAugustin Cavalier			if [ -z `get_variable "crossToolsPrefix_$targetArch"` ] \
74336f28382SAugustin Cavalier					&& [ -z `get_variable buildCrossToolsMachine_$targetArch` ]; then
74465706842SAugustin Cavalier				set_variable crossToolsPrefix_$targetArch llvm-
74565706842SAugustin Cavalier			fi
7465924b6e4SAugustin Cavalier			clangVersion=`$HAIKU_clang -v 2>&1 | head -1 | cut -d " " -f3`
7475924b6e4SAugustin Cavalier			if [ `echo $clangVersion | head -c 1` -lt 7 ]; then
7485924b6e4SAugustin Cavalier				echo "Haiku requires Clang 7 or better to build, but you have $clangVersion."
7495924b6e4SAugustin Cavalier				echo "Please install a newer version."
7505924b6e4SAugustin Cavalier				exit 1
7515924b6e4SAugustin Cavalier			fi
752d73993ffSAugustin Cavalier			targetArchs="$targetArchs $targetArch"
753d73993ffSAugustin Cavalier			shift 2
754d73993ffSAugustin Cavalier			;;
7557c4641d0SOliver Tappe		--use-gcc-pipe)	HAIKU_USE_GCC_PIPE=1; shift 1;;
756c0e8cc1aSIngo Weinhold		--use-gcc-graphite)	useGccGraphiteDefault=1; shift 1;;
7577986925fSIngo Weinhold		--use-32bit)	HAIKU_HOST_USE_32BIT=1; shift 1;;
758fc2c93fbSAugustin Cavalier		--no-full-xattr)HAIKU_HOST_USE_XATTR=0; shift 1;;
759fc2c93fbSAugustin Cavalier		--no-xattr)		HAIKU_HOST_USE_XATTR_REF=0; shift 1;;
7604da6cf84SFrançois Revol		--with-gdb)	gdbSources=$2; shift 2;;
761022fa244SIngo Weinhold		*)				echo Invalid argument: \`$1\'; exit 1;;
762022fa244SIngo Weinhold	esac
763022fa244SIngo Weinholddone
764022fa244SIngo Weinhold
7650df3cc9cSIngo Weinhold# detect the build platform
766338b8dc3SIngo Weinholdcase "${platform}" in
7677c4641d0SOliver Tappe	Darwin)	HOST_PLATFORM=darwin ;;
7687c4641d0SOliver Tappe	FreeBSD)	HOST_PLATFORM=freebsd
7697986925fSIngo Weinhold				if [ "$HAIKU_HOST_USE_32BIT" = 1 ] ; then
7705abd9a46SIngo Weinhold					echo Unsupported platform: FreeBSD ${platformMachine}
771308c212cSIngo Weinhold					exit 1
772308c212cSIngo Weinhold				fi	;;
7737c4641d0SOliver Tappe	Haiku)	HOST_PLATFORM=haiku_host ;;
7747c4641d0SOliver Tappe	Linux)	HOST_PLATFORM=linux ;;
7757c4641d0SOliver Tappe	OpenBSD) HOST_PLATFORM=openbsd ;;
7767c4641d0SOliver Tappe	SunOS)	HOST_PLATFORM=sunos ;;
7777c4641d0SOliver Tappe	CYGWIN_NT-*) HOST_PLATFORM=cygwin ;;
778338b8dc3SIngo Weinhold	*)		echo Unsupported platform: ${platform}
7794cbe4925SAxel Dörfler			exit 1 ;;
7804cbe4925SAxel Dörfleresac
78152a38012Sejakowatz
7820962132cSAlex Smith# check for case-sensitive filesystem
7830962132cSAlex Smithmkdir haikuCaseTest 2>/dev/null
7840962132cSAlex Smithmkdir haikucasetest 2>/dev/null
7850962132cSAlex SmithcaseInsensitive=$?
78697f5a0bdSAlex Smithrmdir haikuCaseTest haikucasetest 2>/dev/null
7870962132cSAlex Smithif [ $caseInsensitive != 0 ]; then
7883ecc5287SMichael Lotz	echo "You need a case-sensitive file-system to build Haiku."
7890962132cSAlex Smith	if [ $HOST_PLATFORM = "darwin" ]; then
7907a05e252SJohn Scipione		echo "You can create a case-sensitive disk image using Disk Utility."
7913ecc5287SMichael Lotz	fi
7920962132cSAlex Smith	exit 1
7933ecc5287SMichael Lotzfi
7943ecc5287SMichael Lotz
795a5c952dbSAugustin Cavalier# check xattr support
796503ef6d4SAugustin Cavalierif [ -z $HAIKU_HOST_USE_XATTR_REF ]; then
797a5c952dbSAugustin Cavalier	check_native_xattrs
798a5c952dbSAugustin Cavalier	attrSupport=$?
799fc2c93fbSAugustin Cavalier	if [ $attrSupport = 2 ] && [ -z $HAIKU_HOST_USE_XATTR ]; then
800fc2c93fbSAugustin Cavalier		HAIKU_HOST_USE_XATTR=1
801a5c952dbSAugustin Cavalier	elif [ $attrSupport = 1 ]; then
802fc2c93fbSAugustin Cavalier		HAIKU_HOST_USE_XATTR_REF=1
803a5c952dbSAugustin Cavalier	fi
804a5c952dbSAugustin Cavalierfi
805fc2c93fbSAugustin Cavalierif [ -z $HAIKU_HOST_USE_XATTR ]; then HAIKU_HOST_USE_XATTR=0; fi
806fc2c93fbSAugustin Cavalierif [ -z $HAIKU_HOST_USE_XATTR_REF ]; then HAIKU_HOST_USE_XATTR_REF=0; fi
807a5c952dbSAugustin Cavalier
808f04f7042SNiels Sascha Reedijk# determine how to invoke sed with extended regexp support for non-GNU sed
809f04f7042SNiels Sascha Reedijkif [ $HOST_PLATFORM = "darwin" ]; then
810f04f7042SNiels Sascha Reedijk	HOST_EXTENDED_REGEX_SED="sed -E"
811f04f7042SNiels Sascha Reedijkfi
812f04f7042SNiels Sascha Reedijk
813cb721c59SFrançois Revol# check if nasm can actually output ELF files
814cb721c59SFrançois Revol# (the stock version in OSX can't)
815cb721c59SFrançois Revol# XXX: should probably only test for x86* arch
8163e6c09cdSAdrien Destuguesif [ "$("$HAIKU_NASM" -hf | grep -c elf'[36][24] ')" -ne "2" ]; then
817cb721c59SFrançois Revol	echo "$HAIKU_NASM cannot generate ELF files. Please install a working version."
818cb721c59SFrançois Revol	if [ $HOST_PLATFORM = "darwin" ]; then
819cb721c59SFrançois Revol		echo "You can install it from Mac Ports."
820cb721c59SFrançois Revol		echo "Mac Ports is available at: http://www.macports.org/"
821cb721c59SFrançois Revol	fi
822cb721c59SFrançois Revol	exit 1
823cb721c59SFrançois Revolfi
824cb721c59SFrançois Revol
825338b8dc3SIngo Weinhold# create output directory
8266e7c6fe5SIngo Weinholdmkdir -p "$buildOutputDir" || exit 1
827338b8dc3SIngo Weinhold
8282ebcd86dSIngo Weinholdif [ "$HAIKU_HOST_BUILD_ONLY" = 1 ]; then
8292ebcd86dSIngo Weinhold	invalidCommand=$sourceDir/build/scripts/host_build_only
8302ebcd86dSIngo Weinhold	HAIKU_AR=$invalidCommand
8312ebcd86dSIngo Weinhold	HAIKU_CC=$invalidCommand
8322ebcd86dSIngo Weinhold	HAIKU_LD=$invalidCommand
8332ebcd86dSIngo Weinhold	HAIKU_OBJCOPY=$invalidCommand
8342ebcd86dSIngo Weinhold	HAIKU_RANLIB=$invalidCommand
8352ebcd86dSIngo Weinhold	HAIKU_ELFEDIT=$invalidCommand
836d6f80927SJonathan Schleifer	HAIKU_NASM=$invalidCommand
8372ebcd86dSIngo Weinhold	HAIKU_STRIP=$invalidCommand
8382ebcd86dSIngo Weinholdelse
839483b28e4SIngo Weinhold	# On Haiku determine target architectures and tools automatically.
840c0e8cc1aSIngo Weinhold	if [ -z "$targetArchs" ]; then
841483b28e4SIngo Weinhold		if [ $HOST_PLATFORM != haiku_host ]; then
842483b28e4SIngo Weinhold			echo "Please specify the build tools to use or build (via" \
843eaef83a9SJeroen Oortwijn				"--cross-tools-prefix or --build-cross-tools) or specify a" \
844483b28e4SIngo Weinhold				"host-only build (--host-only)." >&2
8457f9beaf1SOliver Tappe			echo "For more info, invoke $0 --help"
846483b28e4SIngo Weinhold			exit 1
847483b28e4SIngo Weinhold		fi
848483b28e4SIngo Weinhold
849483b28e4SIngo Weinhold		# determine primary architecture
850dda53eaeSIngo Weinhold		targetArch=`package list -i /system/packages/haiku-*.hpkg \
851483b28e4SIngo Weinhold			| sed '/^\s*architecture:/!d; s,^\s*architecture:\s*,,'`
852483b28e4SIngo Weinhold		is_in_list "$targetArch" "$supportedTargetArchs" || (
853483b28e4SIngo Weinhold			echo "Unsupported target architecture: \"$targetArch\"" >&2
854483b28e4SIngo Weinhold			exit 1
855483b28e4SIngo Weinhold		)
856c0e8cc1aSIngo Weinhold		targetArchs=$targetArch
857483b28e4SIngo Weinhold
858c0e8cc1aSIngo Weinhold		set_default_value HAIKU_AR_$targetArch			ar
859c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CC_$targetArch			gcc
860c0e8cc1aSIngo Weinhold		set_default_value HAIKU_LD_$targetArch			ld
861c0e8cc1aSIngo Weinhold		set_default_value HAIKU_OBJCOPY_$targetArch		objcopy
862c0e8cc1aSIngo Weinhold		set_default_value HAIKU_RANLIB_$targetArch		ranlib
863c0e8cc1aSIngo Weinhold		set_default_value HAIKU_ELFEDIT_$targetArch		elfedit
864c0e8cc1aSIngo Weinhold		set_default_value HAIKU_STRIP_$targetArch		strip
865483b28e4SIngo Weinhold
866483b28e4SIngo Weinhold		# determine secondary architectures
867483b28e4SIngo Weinhold		for targetArch in $supportedTargetArchs; do
86880262a91SMatt Madia			if [ -e /system/packages/haiku_$targetArch-*.hpkg ]; then
869483b28e4SIngo Weinhold				targetArchs="$targetArchs $targetArch"
870483b28e4SIngo Weinhold				set_default_value HAIKU_AR_$targetArch		ar-$targetArch
871483b28e4SIngo Weinhold				set_default_value HAIKU_CC_$targetArch		gcc-$targetArch
872483b28e4SIngo Weinhold				set_default_value HAIKU_LD_$targetArch		ld-$targetArch
873483b28e4SIngo Weinhold				set_default_value HAIKU_OBJCOPY_$targetArch	objcopy-$targetArch
874483b28e4SIngo Weinhold				set_default_value HAIKU_RANLIB_$targetArch	ranlib-$targetArch
875483b28e4SIngo Weinhold				set_default_value HAIKU_ELFEDIT_$targetArch	elfedit-$targetArch
876483b28e4SIngo Weinhold				set_default_value HAIKU_STRIP_$targetArch	strip-$targetArch
877483b28e4SIngo Weinhold			fi
878483b28e4SIngo Weinhold		done
879483b28e4SIngo Weinhold
880483b28e4SIngo Weinhold		# The target architectures might have been specified explicitly.
881483b28e4SIngo Weinhold		if [ -n "$haikuTargetArchs" ]; then
882483b28e4SIngo Weinhold			for targetArch in $haikuTargetArchs; do
883483b28e4SIngo Weinhold				is_in_list "$targetArch" "$targetArchs" || (
884483b28e4SIngo Weinhold					echo "Unsupported target architecture: \"$targetArch\"." \
885483b28e4SIngo Weinhold						"Only native architectures of the host platform can" \
886483b28e4SIngo Weinhold						"be specified." >&2
887483b28e4SIngo Weinhold					exit 1
888483b28e4SIngo Weinhold				)
889483b28e4SIngo Weinhold			done
890483b28e4SIngo Weinhold			targetArchs="$haikuTargetArchs"
891483b28e4SIngo Weinhold		fi
892c0e8cc1aSIngo Weinhold	fi
893c0e8cc1aSIngo Weinhold
89468ccc989SIngo Weinhold	isPrimaryArch=1
895c0e8cc1aSIngo Weinhold	for targetArch in $targetArchs; do
8966c5fcb4fSAugustin Cavalier		# Note: targetArch is "unknown<n>" at this point if a cross-tools
897c0e8cc1aSIngo Weinhold		# prefix was specified. The standard_gcc_settings call below will get
898c0e8cc1aSIngo Weinhold		# the actual architecture.
899c0e8cc1aSIngo Weinhold
90032b50a88SAugustin Cavalier		if test "${HAIKU_PACKAGING_ARCHS#*$targetArch\b}" != "$HAIKU_PACKAGING_ARCHS"; then
9016c5fcb4fSAugustin Cavalier			# somehow we wound up with a duplicate arch; skip this one
9026c5fcb4fSAugustin Cavalier			continue
9036c5fcb4fSAugustin Cavalier		fi
9046c5fcb4fSAugustin Cavalier
905c0e8cc1aSIngo Weinhold		crossToolsPrefix=`get_variable crossToolsPrefix_$targetArch`
906c0e8cc1aSIngo Weinhold
907338b8dc3SIngo Weinhold		# build cross tools from sources
908c0e8cc1aSIngo Weinhold		if [ -n "$buildCrossTools" -a -z "$crossToolsPrefix" ]; then
909c0e8cc1aSIngo Weinhold			crossToolsDir="$outputDir/cross-tools-$targetArch"
910c0e8cc1aSIngo Weinhold			targetMachine=`get_variable buildCrossToolsMachine_$targetArch`
911c0e8cc1aSIngo Weinhold			script="$buildCrossToolsScript"
9128304ec7cSIngo Weinhold			scriptArgs=
913c0e8cc1aSIngo Weinhold			if [ $targetArch != x86_gcc2 ]; then
9148304ec7cSIngo Weinhold				script="${script}_gcc4"
9158304ec7cSIngo Weinhold				scriptArgs="$targetMachine"
9161e93288eSJérôme Duval				set_default_value HAIKU_USE_GCC_GRAPHITE_$targetArch	\
9171e93288eSJérôme Duval					$useGccGraphiteDefault
918c0e8cc1aSIngo Weinhold			fi
91968ccc989SIngo Weinhold			secondaryArch=
92068ccc989SIngo Weinhold			if [ -z "$isPrimaryArch" ]; then
92168ccc989SIngo Weinhold				secondaryArch=$targetArch
92268ccc989SIngo Weinhold			fi
92386de8c37SIngo Weinhold
92486de8c37SIngo Weinhold			case $HOST_PLATFORM in
92586de8c37SIngo Weinhold				freebsd|openbsd)	MAKE=gmake;;
92686de8c37SIngo Weinhold				*)					MAKE=make;;
92786de8c37SIngo Weinhold			esac
92886de8c37SIngo Weinhold
9291f839e89Swaddlesplash			if ! valid_toolchain "${targetMachine}" "${crossToolsDir}" "${buildCrossTools}"; then
93086de8c37SIngo Weinhold				MAKE=$MAKE \
93168ccc989SIngo Weinhold				SECONDARY_ARCH=$secondaryArch \
932c0e8cc1aSIngo Weinhold				HAIKU_USE_GCC_GRAPHITE=`get_variable \
933c0e8cc1aSIngo Weinhold					HAIKU_USE_GCC_GRAPHITE_$targetArch` \
934b3ece905SJérôme Duval				HAIKU_USE_GCC_PIPE=$HAIKU_USE_GCC_PIPE \
9354da6cf84SFrançois Revol				HAIKU_USE_GDB="$gdbSources" \
9368304ec7cSIngo Weinhold				"$script" $scriptArgs "$sourceDir" "$buildCrossTools" \
9378304ec7cSIngo Weinhold					"$crossToolsDir" $buildCrossToolsJobs || exit 1
938825700d3SAugustin Cavalier			else
939825700d3SAugustin Cavalier				echo "$targetArch crosstools already exist in $crossToolsDir; skipping build"
940825700d3SAugustin Cavalier			fi
941c0e8cc1aSIngo Weinhold			crossToolsPrefix="$crossToolsDir/bin/${targetMachine}-"
942338b8dc3SIngo Weinhold		fi
943338b8dc3SIngo Weinhold
944c0e8cc1aSIngo Weinhold		# prepare gcc settings and get the actual target architecture
945a7bddff1SJonathan Schleifer		if [ $useClang = 1 ]; then
946c44472c5SAugustin Cavalier			gcc="$HAIKU_clang -target ${targetMachine}"
947ddf7f643SAugustin Cavalier			if [ ! -z "${crossToolsPrefix}" ]; then
948ddf7f643SAugustin Cavalier				gcc="$gcc -B ${crossToolsPrefix}"
949ddf7f643SAugustin Cavalier			fi
9501f6fe055SAugustin Cavalier
9511f6fe055SAugustin Cavalier			# Clang's compiler intrinsics are not compatible with GCC's or even
9521f6fe055SAugustin Cavalier			# across versions of Clang, so we must collect them for use in the build.
9531f6fe055SAugustin Cavalier			mkdir -p "$outputDir/clang_headers" || exit 1
95420c61bb7SAugustin Cavalier			clangHeadersDir=`$gcc -print-resource-dir`/include/
95520c61bb7SAugustin Cavalier			case $targetArch in
95620c61bb7SAugustin Cavalier				x86*) cp $clangHeadersDir/*intrin* $clangHeadersDir/mm3* "$outputDir/clang_headers" || exit 1 ;;
95720c61bb7SAugustin Cavalier				ppc*) cp $clangHeadersDir/*altivec* "$outputDir/clang_headers" || exit 1 ;;
95820c61bb7SAugustin Cavalier				arm*) cp $clangHeadersDir/*arm* "$outputDir/clang_headers" || exit 1 ;;
95920c61bb7SAugustin Cavalier			esac
960d73993ffSAugustin Cavalier		elif [ -z "${crossToolsPrefix}" ]; then
961d73993ffSAugustin Cavalier			gcc=`get_variable HAIKU_CC_$targetArch`
962a7bddff1SJonathan Schleifer		else
963c0e8cc1aSIngo Weinhold			gcc="${crossToolsPrefix}gcc"
964a7bddff1SJonathan Schleifer		fi
965c0e8cc1aSIngo Weinhold		standard_gcc_settings "$gcc"
966c0e8cc1aSIngo Weinhold		targetArch=$standard_gcc_settings_targetArch
967338b8dc3SIngo Weinhold
968c0e8cc1aSIngo Weinhold		# set default values for flags
969c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CPPFLAGS_$targetArch	""
970c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CCFLAGS_$targetArch		""
971c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CXXFLAGS_$targetArch	""
972252e4f62SAugustin Cavalier		set_default_value HAIKU_LINKFLAGS_$targetArch	""
973c0e8cc1aSIngo Weinhold		set_default_value HAIKU_LDFLAGS_$targetArch		""
974c0e8cc1aSIngo Weinhold		set_default_value HAIKU_ARFLAGS_$targetArch		cru
975c0e8cc1aSIngo Weinhold		set_default_value HAIKU_UNARFLAGS_$targetArch	x
976338b8dc3SIngo Weinhold
977c0e8cc1aSIngo Weinhold		# Override the cross tools variables, if the tools were built or a
978c0e8cc1aSIngo Weinhold		# prefix was specified.
9791c307243SAugustin Cavalier		if [ $useClang = 1 ]; then
9801c307243SAugustin Cavalier			get_build_tool_path LD_$targetArch ld.lld
9811c307243SAugustin Cavalier			get_build_tool_path ELFEDIT_$targetArch elfedit
9821c307243SAugustin Cavalier		elif [ -n "$crossToolsPrefix" ]; then
983c0e8cc1aSIngo Weinhold			get_build_tool_path LD_$targetArch ${crossToolsPrefix}ld
984c0e8cc1aSIngo Weinhold			case `get_variable HAIKU_GCC_RAW_VERSION_$targetArch` in
985133e4131SJérôme Duval				4.*|5.*|6.*|7.*|8.*)
986c0e8cc1aSIngo Weinhold					get_build_tool_path ELFEDIT_$targetArch \
987c0e8cc1aSIngo Weinhold						${crossToolsPrefix}elfedit
988bd16f0ddSAlex Smith				;;
989bd16f0ddSAlex Smith			esac
99052a38012Sejakowatz		fi
9911c307243SAugustin Cavalier		if [ -n "$crossToolsPrefix" ]; then
9921c307243SAugustin Cavalier			get_build_tool_path AR_$targetArch ${crossToolsPrefix}ar
9931c307243SAugustin Cavalier			get_build_tool_path OBJCOPY_$targetArch ${crossToolsPrefix}objcopy
9941c307243SAugustin Cavalier			get_build_tool_path RANLIB_$targetArch ${crossToolsPrefix}ranlib
9951c307243SAugustin Cavalier			get_build_tool_path STRIP_$targetArch ${crossToolsPrefix}strip
9961c307243SAugustin Cavalier		fi
99752a38012Sejakowatz
998ef57df3dSIngo Weinhold		# check whether the Haiku compiler really targets Haiku
999c0e8cc1aSIngo Weinhold		targetMachine=`get_variable HAIKU_GCC_MACHINE_$targetArch`
1000c0e8cc1aSIngo Weinhold		case "$targetMachine" in
1001eedc3d0bSIngo Weinhold			*-*-haiku)	;;
1002c0e8cc1aSIngo Weinhold			*)
1003c0e8cc1aSIngo Weinhold				echo The compiler specified as Haiku target compiler is not a \
1004c0e8cc1aSIngo Weinhold				valid Haiku cross-compiler. Please see ReadMe.cross-compile. >&2
1005eedc3d0bSIngo Weinhold				echo compiler: $HAIKU_CC
1006c0e8cc1aSIngo Weinhold				echo compiler is configured for target: $targetMachine
1007eedc3d0bSIngo Weinhold				exit 1 ;;
1008eedc3d0bSIngo Weinhold		esac
1009c0e8cc1aSIngo Weinhold
1010c0e8cc1aSIngo Weinhold		HAIKU_PACKAGING_ARCHS="$HAIKU_PACKAGING_ARCHS $targetArch"
101168ccc989SIngo Weinhold		isPrimaryArch=
1012c0e8cc1aSIngo Weinhold	done
10132ebcd86dSIngo Weinholdfi
1014eedc3d0bSIngo Weinhold
101552a38012Sejakowatz# Generate BuildConfig
10167c4641d0SOliver Tappecat << EOF > "$buildConfigFile"
1017825700d3SAugustin Cavalier# -- WARNING --
1018825700d3SAugustin Cavalier# This file was AUTOMATICALLY GENERATED by configure, and will be completely
1019825700d3SAugustin Cavalier# overwritten the next time configure is run.
1020825700d3SAugustin Cavalier#
1021825700d3SAugustin Cavalier#d ${currentDir}
1022825700d3SAugustin Cavalier#c ${configurePath}
1023825700d3SAugustin Cavalier#e ${configureEnvirons}
1024825700d3SAugustin Cavalier#a ${configureArgs}
102552a38012Sejakowatz
10267c4641d0SOliver TappeHOST_PLATFORM				?= "${HOST_PLATFORM}" ;
1027b57e7df9SAugustin CavalierTARGET_PLATFORM 			?= "${TARGET_PLATFORM}" ;
1028b57e7df9SAugustin CavalierHAIKU_PACKAGING_ARCHS		?= ${HAIKU_PACKAGING_ARCHS} ;
1029338b8dc3SIngo Weinhold
1030b57e7df9SAugustin CavalierHAIKU_NO_DOWNLOADS			?= "${HAIKU_NO_DOWNLOADS}" ;
103176fa0be3SIngo WeinholdHAIKU_INCLUDE_SOURCES		?= "${HAIKU_INCLUDE_SOURCES}" ;
10327c4641d0SOliver TappeHAIKU_INCLUDE_3RDPARTY		?= "${HAIKU_INCLUDE_3RDPARTY}" ;
10337c4641d0SOliver TappeHAIKU_DISTRO_COMPATIBILITY	?= "${HAIKU_DISTRO_COMPATIBILITY}" ;
1034b57e7df9SAugustin Cavalier
10357c4641d0SOliver TappeHAIKU_USE_GCC_PIPE			?= "${HAIKU_USE_GCC_PIPE}" ;
10367986925fSIngo WeinholdHAIKU_HOST_USE_32BIT		?= "${HAIKU_HOST_USE_32BIT}" ;
10377986925fSIngo WeinholdHAIKU_HOST_USE_XATTR		?= "${HAIKU_HOST_USE_XATTR}" ;
1038bc96e8f3SIngo WeinholdHAIKU_HOST_USE_XATTR_REF	?= "${HAIKU_HOST_USE_XATTR_REF}" ;
10392ebcd86dSIngo WeinholdHAIKU_HOST_BUILD_ONLY		?= "${HAIKU_HOST_BUILD_ONLY}" ;
1040eccc7665SIngo Weinhold
1041b57e7df9SAugustin CavalierHOST_CC						?= ${CC} ;
10427c4641d0SOliver TappeHOST_GCC_RAW_VERSION		?= ${HOST_GCC_RAW_VERSION} ;
10437c4641d0SOliver TappeHOST_GCC_MACHINE			?= ${HOST_GCC_MACHINE} ;
10447c4641d0SOliver TappeHOST_LD						?= ${HOST_GCC_LD} ;
10457c4641d0SOliver TappeHOST_OBJCOPY				?= ${HOST_GCC_OBJCOPY} ;
1046b57e7df9SAugustin CavalierHOST_EXTENDED_REGEX_SED		?= ${HOST_EXTENDED_REGEX_SED} ;
10472a5d0aafSIngo WeinholdHOST_SHA256					?= ${HOST_SHA256} ;
1048b57e7df9SAugustin CavalierHAIKU_NASM					?= ${HAIKU_NASM} ;
1049b57e7df9SAugustin Cavalier
1050b57e7df9SAugustin CavalierHAIKU_BUILD_ATTRIBUTES_DIR	?= ${HAIKU_BUILD_ATTRIBUTES_DIR} ;
10518b5934c9SIngo Weinhold
1052e173a1ecSIngo WeinholdHOST_HAIKU_PORTER			?= ${HOST_HAIKU_PORTER} ;
1053e173a1ecSIngo WeinholdHAIKU_PORTS					?= ${HAIKU_PORTS} ;
1054e173a1ecSIngo WeinholdHAIKU_PORTS_CROSS			?= ${HAIKU_PORTS_CROSS} ;
1055c9dd05ffSJonathan SchleiferHAIKU_IS_BOOTSTRAP			?= ${HAIKU_IS_BOOTSTRAP} ;
1056e173a1ecSIngo Weinhold
1057c4786ea6SlilloEOF
1058c4786ea6Slillo
1059c0e8cc1aSIngo Weinholdfor targetArch in $HAIKU_PACKAGING_ARCHS; do
1060c0e8cc1aSIngo Weinhold	variables="
1061c1249957SAugustin Cavalier		HAIKU_CC					HAIKU_CC
1062c1249957SAugustin Cavalier		HAIKU_CC_IS_CLANG			HAIKU_CC_IS_CLANG
1063c1249957SAugustin Cavalier		HAIKU_USE_GCC_GRAPHITE		HAIKU_USE_GCC_GRAPHITE
1064c0e8cc1aSIngo Weinhold		HAIKU_CPU					HAIKU_CPU
1065c1249957SAugustin Cavalier		HAIKU_GCC_MACHINE			HAIKU_GCC_MACHINE
1066c1249957SAugustin Cavalier		HAIKU_GCC_RAW_VERSION		HAIKU_GCC_RAW_VERSION
1067c1249957SAugustin Cavalier		HAIKU_GCC_LIB_DIR			HAIKU_GCC_LIB_DIR
1068c0e8cc1aSIngo Weinhold		HAIKU_BOOT_LIBGCC			HAIKU_BOOT_LIBGCC
1069c0e8cc1aSIngo Weinhold		HAIKU_BOOT_LIBSUPC++		HAIKU_BOOT_LIBSUPCXX
1070c0e8cc1aSIngo Weinhold		HAIKU_AR					HAIKU_AR
1071c0e8cc1aSIngo Weinhold		HAIKU_LD					HAIKU_LD
1072c0e8cc1aSIngo Weinhold		HAIKU_OBJCOPY				HAIKU_OBJCOPY
1073c0e8cc1aSIngo Weinhold		HAIKU_RANLIB				HAIKU_RANLIB
1074c0e8cc1aSIngo Weinhold		HAIKU_ELFEDIT				HAIKU_ELFEDIT
1075c0e8cc1aSIngo Weinhold		HAIKU_STRIP					HAIKU_STRIP
1076c0e8cc1aSIngo Weinhold		HAIKU_CPPFLAGS				HAIKU_CPPFLAGS
1077c0e8cc1aSIngo Weinhold		HAIKU_CCFLAGS				HAIKU_CCFLAGS
1078c0e8cc1aSIngo Weinhold		HAIKU_C++FLAGS				HAIKU_CXXFLAGS
1079252e4f62SAugustin Cavalier		HAIKU_LINKFLAGS				HAIKU_LINKFLAGS
1080c0e8cc1aSIngo Weinhold		HAIKU_LDFLAGS				HAIKU_LDFLAGS
1081c0e8cc1aSIngo Weinhold		HAIKU_ARFLAGS				HAIKU_ARFLAGS
1082c0e8cc1aSIngo Weinhold		HAIKU_UNARFLAGS				HAIKU_UNARFLAGS
1083c0e8cc1aSIngo Weinhold		"
1084c0e8cc1aSIngo Weinhold	set -- $variables
1085c0e8cc1aSIngo Weinhold	while [ $# -ge 2 ]; do
1086c0e8cc1aSIngo Weinhold		value=`get_variable ${2}_$targetArch`
1087c0e8cc1aSIngo Weinhold		echo "${1}_${targetArch} ?= $value ;" >> "$buildConfigFile"
1088c0e8cc1aSIngo Weinhold		shift 2
1089c0e8cc1aSIngo Weinhold	done
1090b1e5b60cSAxel Dörfler
1091c0e8cc1aSIngo Weinhold	# For variables that may have long values, distribute them over multiple
1092c0e8cc1aSIngo Weinhold	# lines so that jam doesn't hit the maximum line length.
1093c0e8cc1aSIngo Weinhold	variables="
109466a7f29fSJérôme Duval		HAIKU_BOOT_C++_HEADERS_DIR	HAIKU_BOOT_CXX_HEADERS_DIR
1095c0e8cc1aSIngo Weinhold		"
1096c0e8cc1aSIngo Weinhold	set -- $variables
1097c0e8cc1aSIngo Weinhold	while [ $# -ge 2 ]; do
1098c0e8cc1aSIngo Weinhold		echo "${1}_${targetArch} ?= " >> "$buildConfigFile"
1099c0e8cc1aSIngo Weinhold		get_variable ${2}_$targetArch | xargs -n 1 echo "   " \
1100c0e8cc1aSIngo Weinhold			>> "$buildConfigFile"
1101c0e8cc1aSIngo Weinhold		echo "    ;" >> "$buildConfigFile"
1102c0e8cc1aSIngo Weinhold		shift 2
1103c0e8cc1aSIngo Weinhold	done
1104c0e8cc1aSIngo Weinholddone
1105b1e5b60cSAxel Dörfler
1106b1e5b60cSAxel Dörfler
1107*3facc270SAugustin Cavalier# Generate a Jamfile in the output directory.
1108338b8dc3SIngo Weinhold
1109338b8dc3SIngo Weinholdcat << EOF > $outputDir/Jamfile
1110*3facc270SAugustin Cavalier# -- WARNING --
1111*3facc270SAugustin Cavalier# This file was AUTOMATICALLY GENERATED by configure, and will be completely
1112*3facc270SAugustin Cavalier# overwritten the next time configure is run.
1113338b8dc3SIngo Weinhold
1114*3facc270SAugustin CavalierHAIKU_TOP			= $(relative_to "${sourceDir}" "${outputDir}") ;
1115*3facc270SAugustin CavalierHAIKU_OUTPUT_DIR	= . ;
1116338b8dc3SIngo Weinhold
1117338b8dc3SIngo Weinholdinclude [ FDirName \$(HAIKU_TOP) Jamfile ] ;
1118338b8dc3SIngo Weinhold
1119338b8dc3SIngo WeinholdEOF
1120d73993ffSAugustin Cavalier
1121d73993ffSAugustin Cavalierecho "Configured successfully!"
1122